#
# DO NOT MODIFY!!!!
# This file is automatically generated by Racc 1.5.2
# from Racc grammar file "".
#

require 'racc/parser.rb'
module RBS
  class Parser < Racc::Parser

module_eval(<<'...end parser.y/module_eval...', 'parser.y', 1394)

Types = RBS::Types
Namespace = RBS::Namespace
TypeName = RBS::TypeName
Declarations = RBS::AST::Declarations
Members = RBS::AST::Members
MethodType = RBS::MethodType
Annotation = RBS::AST::Annotation

class LocatedValue
  attr_reader :location
  attr_reader :value

  def initialize(location:, value:)
    @location = location
    @value = value
  end
end

attr_reader :input
attr_reader :buffer
attr_reader :eof_re

def initialize(type, buffer:, eof_re:)
  super()
  @type = type
  @buffer = buffer
  @input = CharScanner.new(buffer.content)
  @eof_re = eof_re
  @eof = false
  @bound_variables_stack = []
  @comments = {}
  @ascii_only = buffer.content.ascii_only?
end

def start_merged_variables_scope
  set = @bound_variables_stack.last&.dup || Set.new
  @bound_variables_stack.push set
end

def start_new_variables_scope
  @bound_variables_stack.push Set.new
end

def reset_variable_scope
  @bound_variables_stack.pop
end

def insert_bound_variable(var)
  @bound_variables_stack.last << var
end

def is_bound_variable?(var)
  (@bound_variables_stack.last || Set.new).member?(var)
end

def self.parse_signature(input, eof_re: nil)
  case input
  when RBS::Buffer
    buffer = input
  else
    buffer = RBS::Buffer.new(name: nil, content: input.to_s)
  end

  self.new(:SIGNATURE, buffer: buffer, eof_re: eof_re).do_parse
end

def self.parse_type(input, variables: [], eof_re: nil)
  case input
  when RBS::Buffer
    buffer = input
  else
    buffer = RBS::Buffer.new(name: nil, content: input.to_s)
  end

  self.new(:TYPE, buffer: buffer, eof_re: eof_re).yield_self do |parser|
    parser.start_new_variables_scope

    variables.each do |var|
      parser.insert_bound_variable var
    end

    parser.do_parse
  ensure
    parser.reset_variable_scope
  end
end

def self.parse_method_type(input, variables: [], eof_re: nil)
  case input
  when RBS::Buffer
    buffer = input
  else
    buffer = RBS::Buffer.new(name: nil, content: input.to_s)
  end

  self.new(:METHODTYPE, buffer: buffer, eof_re: eof_re).yield_self do |parser|
    parser.start_new_variables_scope

    variables.each do |var|
      parser.insert_bound_variable var
    end

    parser.do_parse
  ensure
    parser.reset_variable_scope
  end
end

def leading_comment(location)
  @comments[location.start_line-1]
end

def push_comment(string, location)
  if (comment = leading_comment(location)) && comment.location.start_column == location.start_column
    comment.concat(string: "#{string}\n", location: location)
    @comments[comment.location.end_line] = comment
  else
    new_comment = AST::Comment.new(string: "#{string}\n", location: location)
    @comments[new_comment.location.end_line] = new_comment
  end
end

def new_token(type, value = input.matched)
  charpos = charpos(input)
  matched = input.matched

  if matched
    start_index = charpos - matched.size
    end_index = charpos

    location = RBS::Location.new(buffer: buffer,
                                 start_pos: start_index,
                                 end_pos: end_index)

    [type, LocatedValue.new(location: location, value: value)]
  else
    # scanner hasn't matched yet
    [false, nil]
  end
end

def charpos(scanner)
  scanner.charpos
end

def empty_params_result
  [
    [],
    [],
    nil,
    [],
    {},
    {},
    nil
  ]
end

KEYWORDS = {
  "class" => :kCLASS,
  "type" => :kTYPE,
  "def" => :kDEF,
  "self" => :kSELF,
  "void" => :kVOID,
  "any" => :kANY,
  "untyped" => :kUNTYPED,
  "top" => :kTOP,
  "bot" => :kBOT,
  "instance" => :kINSTANCE,
  "bool" => :kBOOL,
  "nil" => :kNIL,
  "true" => :kTRUE,
  "false" => :kFALSE,
  "singleton" => :kSINGLETON,
  "interface" => :kINTERFACE,
  "end" => :kEND,
  "include" => :kINCLUDE,
  "extend" => :kEXTEND,
  "prepend" => :kPREPEND,
  "module" => :kMODULE,
  "attr_reader" => :kATTRREADER,
  "attr_writer" => :kATTRWRITER,
  "attr_accessor" => :kATTRACCESSOR,
  "public" => :kPUBLIC,
  "private" => :kPRIVATE,
  "alias" => :kALIAS,
  "extension" => :kEXTENSION,
  "incompatible" => :kINCOMPATIBLE,
  "unchecked" => :kUNCHECKED,
  "overload" => :kOVERLOAD,
  "out" => :kOUT,
  "in" => :kIN,
}
KEYWORDS_RE = /#{Regexp.union(*KEYWORDS.keys)}\b/

PUNCTS = {
  "===" => :tOPERATOR,
  "==" => :tOPERATOR,
  "=~" => :tOPERATOR,
  "!~" => :tOPERATOR,
  "!=" => :tOPERATOR,
  ">=" => :tOPERATOR,
  "<<" => :tOPERATOR,
  "<=>" => :tOPERATOR,
  "<=" => :tOPERATOR,
  ">>" => :tOPERATOR,
  ">" => :tOPERATOR,
  "~" => :tOPERATOR,
  "+@" => :tOPERATOR,
  "+" => :tOPERATOR,
  "[]=" => :tOPERATOR,
  "[]" => :tOPERATOR,
  "::" => :kCOLON2,
  ":" => :kCOLON,
  "(" => :kLPAREN,
  ")" => :kRPAREN,
  "[" => :kLBRACKET,
  "]" => :kRBRACKET,
  "{" => :kLBRACE,
  "}" => :kRBRACE,
  "," => :kCOMMA,
  "|" => :kBAR,
  "&" => :kAMP,
  "^" => :kHAT,
  "->" => :kARROW,
  "=>" => :kFATARROW,
  "=" => :kEQ,
  "?" => :kQUESTION,
  "!" => :kEXCLAMATION,
  "**" => :kSTAR2,
  "*" => :kSTAR,
  "..." => :kDOT3,
  "." => :kDOT,
  "<" => :kLT,
  "-@" => :tOPERATOR,
  "-" => :tOPERATOR,
  "/" => :tOPERATOR,
  "`" => :tOPERATOR,
  "%" => :tOPERATOR,
}
PUNCTS_RE = Regexp.union(*PUNCTS.keys)

ANNOTATION_RE = Regexp.union(/%a\{.*?\}/,
                             /%a\[.*?\]/,
                             /%a\(.*?\)/,
                             /%a\<.*?\>/,
                             /%a\|.*?\|/)

escape_sequences = %w[a b e f n r s t v "].map { |l| "\\\\#{l}" }
DBL_QUOTE_STR_ESCAPE_SEQUENCES_RE = /(#{escape_sequences.join("|")})/

def next_token
  if @type
    type = @type
    @type = nil
    return [:"type_#{type}", nil]
  end

  return new_token(false, '') if @eof

  while true
    return new_token(false, '') if input.eos?

    case
    when input.scan(/\s+/)
      # skip
    when input.scan(/#(( *)|( ?(?<string>.*)))\n/)
      charpos = charpos(input)
      start_index = charpos - input.matched.size
      end_index = charpos-1

      location = RBS::Location.new(buffer: buffer,
                                               start_pos: start_index,
                                               end_pos: end_index)

      push_comment input[:string] || "", location
    else
      break
    end
  end

  case
  when eof_re && input.scan(eof_re)
    @eof = true
    [:tEOF, input.matched]
  when input.scan(/`[a-zA-Z_]\w*`/)
    s = input.matched.yield_self {|s| s[1, s.length-2] }
    new_token(:tQUOTEDIDENT, s)
  when input.scan(/`(\\`|[^` :])+`/)
    s = input.matched.yield_self {|s| s[1, s.length-2] }.gsub(/\\`/, '`')
    new_token(:tQUOTEDMETHOD, s)
  when input.scan(ANNOTATION_RE)
    s = input.matched.yield_self {|s| s[3, s.length-4] }.strip
    new_token(:tANNOTATION, s)
  when input.scan(/self\?/)
    new_token(:kSELFQ, "self?")
  when input.scan(/(([a-zA-Z]\w*)|(_\w+))=/)
    new_token(:tWRITE_ATTR)
  when input.scan(KEYWORDS_RE)
    new_token(KEYWORDS[input.matched], input.matched.to_sym)
  when input.scan(/:((@{,2}|\$)?\w+(\?|\!)?|[|&\/%~`^]|<=>|={2,3}|=~|[<>]{2}|[<>]=?|[-+]@?|\*{1,2}|\[\]=?|![=~]?)\b?/)
    s = input.matched.yield_self {|s| s[1, s.length] }.to_sym
    new_token(:tSYMBOL, s)
  when input.scan(/[+-]?\d[\d_]*/)
    new_token(:tINTEGER, input.matched.to_i)
  when input.scan(PUNCTS_RE)
    new_token(PUNCTS[input.matched])
  when input.scan(/(::)?([A-Z]\w*::)+/)
    new_token(:tNAMESPACE)
  when input.scan(/[a-z_]\w*:/)
    new_token(:tLKEYWORD, input.matched.chop.to_sym)
  when input.scan(/[a-z_]\w*[?!]:/)
    new_token(:tLKEYWORD_Q_E, input.matched.chop.to_sym)
  when input.scan(/[A-Z]\w*:/)
    new_token(:tUKEYWORD, input.matched.chop.to_sym)
  when input.scan(/[A-Z]\w*[?!]:/)
    new_token(:tUKEYWORD_Q_E, input.matched.chop.to_sym)
  when input.scan(/\$[A-Za-z_]\w*/)
    new_token(:tGLOBALIDENT)
  when input.scan(/@[a-zA-Z_]\w*/)
    new_token(:tIVAR, input.matched.to_sym)
  when input.scan(/@@[a-zA-Z_]\w*/)
    new_token(:tCLASSVAR, input.matched.to_sym)
  when input.scan(/_[a-zA-Z]\w*\b/)
    new_token(:tINTERFACEIDENT)
  when input.scan(/[A-Z]\w*\b/)
    new_token(:tUIDENT)
  when input.scan(/[a-z_]\w*\b/)
    new_token(:tLIDENT)
  when input.scan(/"(\\"|[^"])*"/)
    s = input.matched.yield_self {|s| s[1, s.length - 2] }
                     .gsub(DBL_QUOTE_STR_ESCAPE_SEQUENCES_RE) do |match|
                       case match
                       when '\\a' then "\a"
                       when '\\b' then "\b"
                       when '\\e' then "\e"
                       when '\\f' then "\f"
                       when '\\n' then "\n"
                       when '\\r' then "\r"
                       when '\\s' then "\s"
                       when '\\t' then "\t"
                       when '\\v' then "\v"
                       when '\\"' then '"'
                       end
                     end
    new_token(:tSTRING, s)
  when input.scan(/'(\\'|[^'])*'/)
    s = input.matched.yield_self {|s| s[1, s.length - 2] }.gsub(/\\'/, "'")
    new_token(:tSTRING, s)
  else
    text = input.peek(10)
    start_index = charpos(input)
    end_index = start_index + text.length
    location = RBS::Location.new(buffer: buffer, start_pos: start_index, end_pos: end_index)
    raise LexerError.new(input: text, location: location)
  end
end

def on_error(token_id, error_value, value_stack)
  raise SyntaxError.new(token_str: token_to_str(token_id), error_value: error_value, value_stack: value_stack)
end

def split_kw_loc(loc)
  buf = loc.buffer
  start_pos = loc.start_pos
  end_pos = loc.end_pos
  [
    Location.new(buffer: buf, start_pos: start_pos, end_pos: end_pos - 1),
    Location.new(buffer: buf, start_pos: end_pos - 1, end_pos: end_pos)
  ]
end

class SyntaxError < ParsingError
  attr_reader :token_str, :error_value, :value_stack

  def initialize(token_str:, error_value:, value_stack: nil)
    @token_str = token_str
    @error_value = error_value
    @value_stack = value_stack

    super "parse error on value: #{error_value.inspect} (#{token_str})"
  end
end

class SemanticsError < ParsingError
  attr_reader :subject, :location, :original_message

  def initialize(message, subject:, location:)
    @subject = subject
    @location = location
    @original_message = message

    super "parse error on #{location}: #{message}"
  end
end

class LexerError < ParsingError
  attr_reader :location, :input

  def initialize(input:, location:)
    @input = input
    @location = location

    super "Unexpected string: #{input}..."
  end
end

...end parser.y/module_eval...
##### State transition tables begin ###

clist = [
'349,350,33,351,-4,113,-242,33,33,5,117,336,-242,33,33,348,37,113,42',
'334,40,41,55,56,57,58,59,60,61,62,353,43,63,54,64,65,66,77,67,68,69',
'83,33,32,33,344,338,339,32,32,342,340,343,291,32,32,49,341,82,70,71',
'72,74,76,75,337,346,347,73,78,80,349,350,33,351,84,85,81,86,33,39,405',
'48,32,33,32,348,104,53,404,40,41,49,55,56,57,58,59,60,61,62,79,33,63',
'54,64,65,66,77,67,68,69,83,33,32,160,344,338,339,33,32,342,340,343,53',
'32,322,207,341,82,70,71,72,74,76,75,337,346,347,73,78,80,126,32,161',
'320,84,85,81,86,349,350,39,351,32,96,97,98,99,53,32,207,180,40,41,348',
'40,41,179,185,40,41,55,56,57,58,59,60,61,62,79,226,63,54,64,65,66,77',
'67,68,69,83,39,53,186,344,338,339,281,332,342,340,343,2,3,4,227,341',
'82,70,71,72,74,76,75,337,346,347,73,78,80,364,396,282,186,84,85,81,86',
'349,350,120,351,180,96,97,98,99,125,262,101,102,165,103,348,166,186',
'186,408,40,41,55,56,57,58,59,60,61,62,79,409,63,54,64,65,66,77,67,68',
'69,83,40,41,186,344,338,339,40,41,342,340,343,40,41,167,186,341,82,70',
'71,72,74,76,75,337,346,347,73,78,80,40,41,40,41,84,85,81,86,349,350',
'168,351,170,96,97,98,99,40,41,40,41,40,41,348,40,41,284,285,367,368',
'55,56,57,58,59,60,61,62,79,171,63,54,64,65,66,77,67,68,69,83,40,41,172',
'344,338,339,40,41,342,340,343,383,384,40,41,341,82,70,71,72,74,76,75',
'337,346,347,73,78,80,349,350,113,351,84,85,81,86,40,41,40,41,40,41,178',
'348,40,41,40,41,40,41,55,56,57,58,59,60,61,62,79,181,63,54,64,65,66',
'77,67,68,69,83,184,41,187,344,338,339,189,180,342,340,343,190,-104,-105',
'-106,341,82,70,71,72,74,76,75,337,346,347,73,78,80,-107,-108,-109,-110',
'84,85,81,86,349,350,-111,351,-112,96,97,98,99,-113,-114,48,-129,195',
'196,348,197,198,199,200,208,209,55,56,57,58,59,60,61,62,79,42,63,54',
'64,65,66,77,67,68,69,83,210,228,242,344,338,339,251,252,342,340,343',
'253,255,257,258,341,82,70,71,72,74,76,75,337,346,347,73,78,80,349,350',
'42,351,84,85,81,86,260,260,260,264,42,228,268,348,272,274,289,290,313',
'272,55,56,57,58,59,60,61,62,79,315,63,54,64,65,66,77,67,68,69,83,289',
'328,329,344,338,339,330,355,342,340,343,355,355,363,365,341,82,70,71',
'72,74,76,75,337,346,347,73,78,80,366,369,371,378,84,85,81,86,33,379',
'380,96,97,98,99,388,388,388,22,23,21,400,26,-219,25,401,30,402,131,132',
'133,134,135,136,137,138,142,16,139,130,140,141,66,77,67,68,69,83,403',
'32,406,407,412,28,413,156,414,157,159,416,419,412,,,82,70,71,72,74,76',
'75,,,,73,78,80,,,,,84,85,81,86,33,,,96,97,98,99,,,,22,23,21,,26,,25',
',30,,131,132,133,134,135,136,137,138,142,16,139,130,140,141,66,77,67',
'68,69,83,,32,,,174,28,,177,,175,,,,,,,82,70,71,72,74,76,75,,,,73,78',
'80,176,,,,84,85,81,86,33,,,96,97,98,99,,,,22,23,21,,26,-219,25,,30,',
'131,132,133,134,135,136,137,138,142,16,139,130,140,141,66,77,67,68,69',
'83,,32,,,,28,,156,,157,159,,,,,,82,70,71,72,74,76,75,,,,73,78,80,,,',
',84,85,81,86,33,,,96,97,98,99,,,,22,23,21,,26,-219,25,,30,,131,132,133',
'134,135,136,137,138,142,16,139,130,140,141,66,77,67,68,69,83,,32,,,',
'28,,156,,157,159,,,,,,82,70,71,72,74,76,75,,,,73,78,80,,,,,84,85,81',
'86,33,,,96,97,98,99,,,,22,23,21,,26,-219,25,,30,,131,132,133,134,135',
'136,137,138,142,16,139,130,140,141,66,77,67,68,69,83,,32,,,,28,,234',
',,159,,,,,,82,70,71,72,74,76,75,,,,73,78,80,,,,,84,85,81,86,33,,,96',
'97,98,99,,,,22,23,21,,26,-219,25,,30,,131,132,133,134,135,136,137,138',
'142,16,139,130,140,141,66,77,67,68,69,83,,32,,,,28,,156,,157,159,,,',
',,82,70,71,72,74,76,75,,,,73,78,80,,,,,84,85,81,86,33,,,96,97,98,99',
',,,22,23,21,,26,-219,25,,30,,131,132,133,134,135,136,137,138,142,16',
'139,130,140,141,66,77,67,68,69,83,,32,,,,28,,234,,,159,,,,,,82,70,71',
'72,74,76,75,,,,73,78,80,,,,,84,85,81,86,96,97,98,99,,,,90,89,91,,,,',
',,,55,56,57,58,59,60,61,62,79,,63,54,64,65,66,77,67,68,69,83,,,,,,,',
',192,,193,,,,,,82,70,71,72,74,76,75,,95,94,73,78,80,,,,,84,85,81,86',
'96,97,98,99,,,,90,89,91,,,,,,40,41,55,56,57,58,59,60,61,62,79,,63,54',
'64,65,66,77,67,68,69,83,194,,,,,,,,,,,,,,,,82,70,71,72,74,76,75,,95',
'94,73,78,80,96,97,98,99,84,85,81,86,,,,,,,,,,55,56,57,58,59,60,61,62',
'79,,63,54,64,65,66,77,67,68,69,83,192,,193,,,,,234,,,159,,,,,,82,70',
'71,72,74,76,75,192,,193,73,78,80,96,97,98,99,84,85,81,86,,,,,,,,40,41',
'55,56,57,58,59,60,61,62,79,,63,54,64,65,66,77,67,68,69,83,194,40,41',
',,,,234,,,159,,,,,,82,70,71,72,74,76,75,194,,,73,78,80,96,97,98,99,84',
'85,81,86,,,,,,,,,,55,56,57,58,59,60,61,62,79,,63,54,64,65,66,77,67,68',
'69,83,192,,193,192,,193,192,,193,,,,,,,,82,70,71,72,74,76,75,,,,73,78',
'80,,,,,84,85,81,86,,,,,,,,40,41,,40,41,,40,41,-242,,33,,117,,-242,,',
'310,311,113,,,194,,,194,,,194,,-242,,33,,117,,-242,,312,310,311,113',
',,,,,307,306,,,32,-242,,33,,117,,-242,,312,310,311,113,,,,298,,307,306',
',174,32,,177,,175,,,322,,312,,,,,,,316,,307,306,,33,32,,176,,320,326',
'323,324,325,22,23,21,327,26,,25,317,30,,8,12,19,20,9,10,13,14,15,16',
'17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,45,30,,8,12,19,20,9,10',
'13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12',
'19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25',
',30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23',
'21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32',
',,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27',
',,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16',
'17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10',
'13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,-246,30,',
'8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,',
'26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28',
'22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,',
',,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18',
'11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14',
'15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20',
'9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30',
',8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21',
',26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,',
'28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33',
',,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18',
'11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14',
'15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20',
'9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30',
',8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21',
',26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,',
'28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33',
',,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18',
'11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14',
'15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20',
'9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30',
',8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21',
',26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,',
'28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33',
',,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18',
'11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14',
'15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20',
'9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30',
',8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21',
',26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,',
'28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33',
',,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18',
'11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20,9,10,13,14',
'15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30,,8,12,19,20',
'9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21,,26,,25,,30',
',8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,33,,,,,32,,,,28,22,23,21',
',26,,25,,30,,8,12,19,20,9,10,13,14,15,16,17,18,11,27,,,,,,,,32,,,,28' ]
        racc_action_table = arr = ::Array.new(3044, nil)
        idx = 0
        clist.each do |str|
          str.split(',', -1).each do |i|
            arr[idx] = i.to_i unless i.empty?
            idx += 1
          end
        end

clist = [
'322,322,48,322,34,278,34,177,34,1,34,321,34,218,219,322,5,34,7,321,44',
'44,322,322,322,322,322,322,322,322,322,24,322,322,322,322,322,322,322',
'322,322,322,220,48,262,322,322,322,177,34,322,322,322,278,218,219,28',
'322,322,322,322,322,322,322,322,322,322,322,322,322,322,354,354,268',
'354,322,322,322,322,274,34,388,27,220,289,262,354,32,28,388,169,169',
'119,354,354,354,354,354,354,354,354,354,320,354,354,354,354,354,354',
'354,354,354,354,326,268,51,354,354,354,327,274,354,354,354,119,289,296',
'160,354,354,354,354,354,354,354,354,354,354,354,354,354,354,47,320,51',
'296,354,354,354,354,356,356,35,356,326,356,356,356,356,160,327,208,116',
'6,6,356,188,188,116,123,47,47,356,356,356,356,356,356,356,356,356,183',
'356,356,356,356,356,356,356,356,356,356,6,208,123,356,356,356,269,319',
'356,356,356,0,0,0,183,356,356,356,356,356,356,356,356,356,356,356,356',
'356,356,331,381,269,319,356,356,356,356,357,357,36,357,248,357,357,357',
'357,46,248,31,31,87,31,357,89,331,381,393,212,212,357,357,357,357,357',
'357,357,357,357,394,357,357,357,357,357,357,357,357,357,357,213,213',
'393,357,357,357,214,214,357,357,357,215,215,90,394,357,357,357,357,357',
'357,357,357,357,357,357,357,357,357,216,216,217,217,357,357,357,357',
'358,358,91,358,93,358,358,358,358,223,223,224,224,225,225,358,265,265',
'271,271,345,345,358,358,358,358,358,358,358,358,358,94,358,358,358,358',
'358,358,358,358,358,358,361,361,95,358,358,358,362,362,358,358,358,366',
'366,386,386,358,358,358,358,358,358,358,358,358,358,358,358,358,358',
'369,369,113,369,358,358,358,358,389,389,391,391,395,395,115,369,415',
'415,417,417,418,418,369,369,369,369,369,369,369,369,369,117,369,369',
'369,369,369,369,369,369,369,369,120,121,124,369,369,369,127,128,369',
'369,369,129,130,131,132,369,369,369,369,369,369,369,369,369,369,369',
'369,369,369,133,134,135,136,369,369,369,369,382,382,137,382,138,382',
'382,382,382,139,140,141,142,145,146,382,148,150,153,154,161,162,382',
'382,382,382,382,382,382,382,382,163,382,382,382,382,382,382,382,382',
'382,382,164,190,206,382,382,382,221,222,382,382,382,227,232,243,244',
'382,382,382,382,382,382,382,382,382,382,382,382,382,382,414,414,245',
'414,382,382,382,382,246,247,249,250,254,257,259,414,260,261,275,277',
'280,282,414,414,414,414,414,414,414,414,414,283,414,414,414,414,414',
'414,414,414,414,414,287,310,311,414,414,414,312,323,414,414,414,324',
'325,330,333,414,414,414,414,414,414,414,414,414,414,414,414,414,414',
'335,353,355,359,414,414,414,414,49,360,363,49,49,49,49,373,375,377,49',
'49,49,383,49,49,49,384,49,385,49,49,49,49,49,49,49,49,49,49,49,49,49',
'49,49,49,49,49,49,49,387,49,390,392,397,49,399,49,402,49,49,405,411',
'419,,,49,49,49,49,49,49,49,,,,49,49,49,,,,,49,49,49,49,156,,,156,156',
'156,156,,,,156,156,156,,156,,156,,156,,156,156,156,156,156,156,156,156',
'156,156,156,156,156,156,156,156,156,156,156,156,,156,,,114,156,,114',
',114,,,,,,,156,156,156,156,156,156,156,,,,156,156,156,114,,,,156,156',
'156,156,196,,,196,196,196,196,,,,196,196,196,,196,196,196,,196,,196',
'196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196',
'196,196,,196,,,,196,,196,,196,196,,,,,,196,196,196,196,196,196,196,',
',,196,196,196,,,,,196,196,196,196,197,,,197,197,197,197,,,,197,197,197',
',197,197,197,,197,,197,197,197,197,197,197,197,197,197,197,197,197,197',
'197,197,197,197,197,197,197,,197,,,,197,,197,,197,197,,,,,,197,197,197',
'197,197,197,197,,,,197,197,197,,,,,197,197,197,197,198,,,198,198,198',
'198,,,,198,198,198,,198,198,198,,198,,198,198,198,198,198,198,198,198',
'198,198,198,198,198,198,198,198,198,198,198,198,,198,,,,198,,198,,,198',
',,,,,198,198,198,198,198,198,198,,,,198,198,198,,,,,198,198,198,198',
'207,,,207,207,207,207,,,,207,207,207,,207,207,207,,207,,207,207,207',
'207,207,207,207,207,207,207,207,207,207,207,207,207,207,207,207,207',
',207,,,,207,,207,,207,207,,,,,,207,207,207,207,207,207,207,,,,207,207',
'207,,,,,207,207,207,207,255,,,255,255,255,255,,,,255,255,255,,255,255',
'255,,255,,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255',
'255,255,255,255,255,,255,,,,255,,255,,,255,,,,,,255,255,255,255,255',
'255,255,,,,255,255,255,,,,,255,255,255,255,30,30,30,30,,,,30,30,30,',
',,,,,,30,30,30,30,30,30,30,30,30,,30,30,30,30,30,30,30,30,30,30,,,,',
',,,,143,,143,,,,,,30,30,30,30,30,30,30,,30,30,30,30,30,,,,,30,30,30',
'30,165,165,165,165,,,,165,165,165,,,,,,143,143,165,165,165,165,165,165',
'165,165,165,,165,165,165,165,165,165,165,165,165,165,143,,,,,,,,,,,',
',,,,165,165,165,165,165,165,165,,165,165,165,165,165,199,199,199,199',
'165,165,165,165,,,,,,,,,,199,199,199,199,199,199,199,199,199,,199,199',
'199,199,199,199,199,199,199,199,201,,201,,,,,199,,,199,,,,,,199,199',
'199,199,199,199,199,203,,203,199,199,199,200,200,200,200,199,199,199',
'199,,,,,,,,201,201,200,200,200,200,200,200,200,200,200,,200,200,200',
'200,200,200,200,200,200,200,201,203,203,,,,,200,,,200,,,,,,200,200,200',
'200,200,200,200,203,,,200,200,200,234,234,234,234,200,200,200,200,,',
',,,,,,,234,234,234,234,234,234,234,234,234,,234,234,234,234,234,234',
'234,234,234,234,204,,204,205,,205,238,,238,,,,,,,,234,234,234,234,234',
'234,234,,,,234,234,234,,,,,234,234,234,234,,,,,,,,204,204,,205,205,',
'238,238,279,,279,,279,,279,,,279,279,279,,,204,,,205,,,238,,286,,286',
',286,,286,,279,286,286,286,,,,,,279,279,,,279,288,,288,,288,,288,,286',
'288,288,288,,,,279,,286,286,,297,286,,297,,297,,,297,,288,,,,,,,286',
',288,288,,2,288,,297,,297,297,297,297,297,2,2,2,297,2,,2,288,2,,2,2',
'2,2,2,2,2,2,2,2,2,2,2,2,,,25,,,,,2,,,,2,25,25,25,,25,,25,25,25,,25,25',
'25,25,25,25,25,25,25,25,25,25,25,25,,,26,,,,,25,,,,25,26,26,26,,26,',
'26,,26,,26,26,26,26,26,26,26,26,26,26,26,26,26,26,,,40,,,,,26,,,,26',
'40,40,40,,40,,40,,40,,40,40,40,40,40,40,40,40,40,40,40,40,40,40,,,41',
',,,,40,,,,40,41,41,41,,41,,41,,41,,41,41,41,41,41,41,41,41,41,41,41',
'41,41,41,,,43,,,,,41,,,,41,43,43,43,,43,,43,,43,,43,43,43,43,43,43,43',
'43,43,43,43,43,43,43,,,53,,,,,43,,,,43,53,53,53,,53,,53,,53,,53,53,53',
'53,53,53,53,53,53,53,53,53,53,53,,,92,,,,,53,,,,53,92,92,92,,92,,92',
',92,,92,92,92,92,92,92,92,92,92,92,92,92,92,92,,,125,,,,,92,,,,92,125',
'125,125,,125,,125,125,125,,125,125,125,125,125,125,125,125,125,125,125',
'125,125,125,,,157,,,,,125,,,,125,157,157,157,,157,,157,,157,,157,157',
'157,157,157,157,157,157,157,157,157,157,157,157,,,158,,,,,157,,,,157',
'158,158,158,,158,,158,,158,,158,158,158,158,158,158,158,158,158,158',
'158,158,158,158,,,159,,,,,158,,,,158,159,159,159,,159,,159,,159,,159',
'159,159,159,159,159,159,159,159,159,159,159,159,159,,,166,,,,,159,,',
',159,166,166,166,,166,,166,,166,,166,166,166,166,166,166,166,166,166',
'166,166,166,166,166,,,167,,,,,166,,,,166,167,167,167,,167,,167,,167',
',167,167,167,167,167,167,167,167,167,167,167,167,167,167,,,168,,,,,167',
',,,167,168,168,168,,168,,168,,168,,168,168,168,168,168,168,168,168,168',
'168,168,168,168,168,,,170,,,,,168,,,,168,170,170,170,,170,,170,,170',
',170,170,170,170,170,170,170,170,170,170,170,170,170,170,,,171,,,,,170',
',,,170,171,171,171,,171,,171,,171,,171,171,171,171,171,171,171,171,171',
'171,171,171,171,171,,,172,,,,,171,,,,171,172,172,172,,172,,172,,172',
',172,172,172,172,172,172,172,172,172,172,172,172,172,172,,,178,,,,,172',
',,,172,178,178,178,,178,,178,,178,,178,178,178,178,178,178,178,178,178',
'178,178,178,178,178,,,179,,,,,178,,,,178,179,179,179,,179,,179,,179',
',179,179,179,179,179,179,179,179,179,179,179,179,179,179,,,181,,,,,179',
',,,179,181,181,181,,181,,181,,181,,181,181,181,181,181,181,181,181,181',
'181,181,181,181,181,,,186,,,,,181,,,,181,186,186,186,,186,,186,,186',
',186,186,186,186,186,186,186,186,186,186,186,186,186,186,,,202,,,,,186',
',,,186,202,202,202,,202,,202,,202,,202,202,202,202,202,202,202,202,202',
'202,202,202,202,202,,,209,,,,,202,,,,202,209,209,209,,209,,209,,209',
',209,209,209,209,209,209,209,209,209,209,209,209,209,209,,,228,,,,,209',
',,,209,228,228,228,,228,,228,,228,,228,228,228,228,228,228,228,228,228',
'228,228,228,228,228,,,251,,,,,228,,,,228,251,251,251,,251,,251,,251',
',251,251,251,251,251,251,251,251,251,251,251,251,251,251,,,290,,,,,251',
',,,251,290,290,290,,290,,290,,290,,290,290,290,290,290,290,290,290,290',
'290,290,290,290,290,,,313,,,,,290,,,,290,313,313,313,,313,,313,,313',
',313,313,313,313,313,313,313,313,313,313,313,313,313,313,,,328,,,,,313',
',,,313,328,328,328,,328,,328,,328,,328,328,328,328,328,328,328,328,328',
'328,328,328,328,328,,,329,,,,,328,,,,328,329,329,329,,329,,329,,329',
',329,329,329,329,329,329,329,329,329,329,329,329,329,329,,,365,,,,,329',
',,,329,365,365,365,,365,,365,,365,,365,365,365,365,365,365,365,365,365',
'365,365,365,365,365,,,372,,,,,365,,,,365,372,372,372,,372,,372,,372',
',372,372,372,372,372,372,372,372,372,372,372,372,372,372,,,374,,,,,372',
',,,372,374,374,374,,374,,374,,374,,374,374,374,374,374,374,374,374,374',
'374,374,374,374,374,,,376,,,,,374,,,,374,376,376,376,,376,,376,,376',
',376,376,376,376,376,376,376,376,376,376,376,376,376,376,,,378,,,,,376',
',,,376,378,378,378,,378,,378,,378,,378,378,378,378,378,378,378,378,378',
'378,378,378,378,378,,,379,,,,,378,,,,378,379,379,379,,379,,379,,379',
',379,379,379,379,379,379,379,379,379,379,379,379,379,379,,,380,,,,,379',
',,,379,380,380,380,,380,,380,,380,,380,380,380,380,380,380,380,380,380',
'380,380,380,380,380,,,403,,,,,380,,,,380,403,403,403,,403,,403,,403',
',403,403,403,403,403,403,403,403,403,403,403,403,403,403,,,406,,,,,403',
',,,403,406,406,406,,406,,406,,406,,406,406,406,406,406,406,406,406,406',
'406,406,406,406,406,,,407,,,,,406,,,,406,407,407,407,,407,,407,,407',
',407,407,407,407,407,407,407,407,407,407,407,407,407,407,,,,,,,,407',
',,,407' ]
        racc_action_check = arr = ::Array.new(3044, nil)
        idx = 0
        clist.each do |str|
          str.split(',', -1).each do |i|
            arr[idx] = i.to_i unless i.empty?
            idx += 1
          end
        end

racc_action_pointer = [
   130,     9,  1590,   nil,   nil,    16,   116,   -33,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,    11,  1626,  1662,    64,    38,   nil,
  1140,   238,    83,   nil,     4,    76,   211,   nil,   nil,   nil,
  1698,  1734,   nil,  1770,   -27,   nil,   192,   123,    -2,   604,
   nil,    93,   nil,  1806,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   196,   nil,   190,
   229,   255,  1842,   268,   295,   308,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   368,   694,   349,   160,   366,   nil,    74,
   419,   374,   nil,   148,   402,  1878,   nil,   408,   426,   413,
   389,   390,   391,   406,   407,   408,   409,   416,   418,   423,
   424,   451,   426,  1189,   nil,   427,   426,   nil,   428,   nil,
   429,   nil,   nil,   430,   431,   nil,   681,  1914,  1950,  1986,
   109,   456,   429,   438,   477,  1214,  2022,  2058,  2094,    43,
  2130,  2166,  2202,   nil,   nil,   nil,   nil,     3,  2238,  2274,
   nil,  2310,   nil,   160,   nil,   nil,  2346,   nil,   119,   nil,
   451,   nil,   nil,   nil,   nil,   nil,   758,   835,   912,  1280,
  1346,  1321,  2382,  1344,  1453,  1456,   479,   989,   143,  2418,
   nil,   nil,   202,   224,   230,   235,   253,   255,     9,    10,
    38,   450,   504,   270,   272,   274,   nil,   509,  2454,   nil,
   nil,   nil,   466,   nil,  1412,   nil,   nil,   nil,  1459,   nil,
   nil,   nil,   nil,   494,   491,   480,   517,   518,   231,   519,
   535,  2490,   nil,   nil,   490,  1066,   nil,   492,   nil,   484,
   466,   502,    40,   nil,   nil,   277,   nil,   nil,    69,   177,
   nil,   249,   nil,   nil,    75,   501,   nil,   528,    -8,  1506,
   529,   nil,   471,   558,   nil,   nil,  1528,   525,  1550,    80,
  2526,   nil,   nil,   nil,   nil,   nil,    83,  1537,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   528,   529,   520,  2562,   nil,   nil,   nil,   nil,   nil,   178,
    98,   -61,    -2,   546,   550,   551,   109,   115,  2598,  2634,
   573,   200,   nil,   565,   nil,   561,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   277,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   544,    69,   545,   148,   227,   306,   583,
   589,   303,   309,   566,   nil,  2670,   329,   nil,   nil,   377,
   nil,   nil,  2706,   597,  2742,   598,  2778,   599,  2814,  2850,
  2886,   201,   456,   564,   568,   595,   316,   604,    70,   340,
   606,   342,   607,   227,   239,   344,   nil,   594,   nil,   610,
   nil,   nil,   599,  2922,   nil,   640,  2958,  2994,   nil,   nil,
   nil,   613,   nil,   nil,   527,   348,   nil,   350,   352,   603,
   nil,   nil ]

racc_action_default = [
  -248,  -248,  -242,    -6,   -15,  -248,    -4,  -157,  -160,  -161,
  -162,  -163,  -164,  -165,  -166,  -167,  -168,  -169,  -170,  -171,
  -172,  -173,  -174,  -175,  -176,  -242,  -242,  -248,   -80,  -184,
  -248,  -248,  -243,  -245,   -16,    -4,  -147,   422,    -1,    -5,
  -242,  -242,  -183,  -242,  -185,  -178,  -247,  -248,  -242,  -242,
  -182,  -248,  -204,  -242,  -104,  -105,  -106,  -107,  -108,  -109,
  -110,  -111,  -112,  -113,  -114,  -115,  -116,  -117,  -118,  -119,
  -120,  -121,  -122,  -123,  -124,  -125,  -126,  -127,  -128,  -129,
  -130,  -131,  -132,  -133,  -134,  -135,  -136,  -247,  -188,  -248,
  -248,  -248,  -242,  -248,  -248,  -248,  -199,  -200,  -201,  -202,
  -235,  -236,  -237,  -238,  -244,    -2,    -7,    -8,    -9,   -10,
   -11,   -12,   -13,   -16,  -248,  -248,  -248,  -248,    -3,   -80,
  -248,  -158,  -159,  -248,  -248,  -242,  -180,  -248,  -248,  -248,
  -170,  -160,  -164,  -171,  -172,  -161,  -162,  -165,  -166,  -169,
  -163,  -115,  -167,  -231,  -197,  -248,  -208,  -209,  -211,  -212,
  -214,  -215,  -218,  -221,  -223,  -224,  -242,  -242,  -242,  -242,
  -248,  -248,  -248,  -206,  -248,  -246,  -242,  -242,  -242,  -193,
  -242,  -242,  -242,   -17,   -14,   -14,   -14,  -242,  -242,  -242,
  -240,  -242,   -79,  -248,  -149,  -177,  -242,  -179,  -186,  -181,
   -81,  -225,  -232,  -233,  -234,  -198,  -242,  -242,  -242,  -219,
  -219,  -231,  -242,  -231,  -231,  -231,  -248,  -242,  -248,  -242,
  -187,  -189,  -190,  -191,  -192,  -194,  -195,  -196,  -242,  -242,
  -242,  -248,  -248,  -154,  -155,  -156,  -148,  -248,  -242,  -207,
  -215,  -210,  -217,  -213,  -248,  -220,  -222,  -226,  -231,  -227,
  -228,  -230,   -82,  -248,  -248,  -203,  -137,  -137,  -248,  -137,
  -248,  -242,  -241,  -150,  -205,  -242,  -229,  -248,   -83,   -19,
  -145,   -24,  -242,   -57,  -239,  -153,  -216,   -30,  -242,  -248,
  -139,  -142,  -146,   -30,  -242,   -30,   -26,   -29,   -16,   -16,
   -20,  -138,  -145,  -248,  -143,  -144,   -16,   -25,   -16,  -242,
  -242,   -56,   -58,   -59,   -60,   -61,   -71,   -71,   -18,   -31,
   -32,   -33,   -34,   -35,   -36,   -37,   -38,   -39,   -40,   -41,
  -248,  -248,  -248,  -242,  -140,  -141,   -22,   -23,   -27,  -248,
  -242,   -68,  -248,   -42,   -42,   -42,  -242,  -242,  -242,  -242,
  -248,  -248,   -28,   -62,   -69,  -248,   -72,   -86,   -87,   -88,
   -89,   -90,   -91,   -92,   -93,   -94,   -97,   -98,   -99,  -100,
  -101,  -102,  -103,  -129,  -248,  -248,  -248,  -248,  -248,   -64,
   -66,   -53,   -54,  -248,   -21,  -242,   -73,   -95,   -96,  -248,
  -151,   -43,  -242,   -50,  -242,   -50,  -242,   -50,  -242,  -242,
  -242,  -248,  -248,  -248,  -248,  -248,   -44,  -248,  -248,   -46,
  -248,   -48,  -248,  -248,  -248,   -55,   -63,   -15,   -84,  -248,
   -74,   -75,  -248,  -242,   -51,  -248,  -242,  -242,   -65,   -67,
   -70,   -76,   -77,   -85,  -248,   -45,   -52,   -47,   -49,   -15,
  -152,   -78 ]

racc_goto_table = [
     6,    46,   116,   127,    93,   163,   114,    92,    88,   191,
    50,   202,   206,   129,   354,   277,   128,   124,   230,   123,
   233,   410,   270,    38,    47,   232,   232,   277,   275,   279,
   387,     1,   390,    34,   392,   286,    35,   288,   121,   122,
   287,   106,   277,   421,   314,   267,   370,   143,   373,   375,
   377,   105,   118,   259,   261,   273,   263,   318,   164,   293,
   244,   385,   218,   219,   220,   235,   236,   237,   294,   239,
   240,   241,   295,   333,   399,   249,   278,   266,   292,   359,
   360,   335,   382,   232,   397,   173,   356,   357,   358,   202,
   169,   119,   162,   269,   283,   183,   221,    87,   231,   100,
   nil,   182,   nil,   nil,   256,   nil,   420,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   188,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    93,
   nil,   nil,    92,   211,   nil,   222,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   201,   203,   204,   205,   nil,   nil,
   229,   245,   nil,   nil,   212,   213,   214,   nil,   215,   216,
   217,   243,   nil,   246,   247,   nil,   223,   224,   nil,   225,
   254,   nil,   nil,   nil,   188,   nil,   128,   248,   250,   nil,
   nil,   nil,   nil,   nil,   143,   143,   143,   nil,   nil,   nil,
   238,   nil,   nil,   nil,   nil,   143,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   280,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   128,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   116,   nil,   265,
   296,   nil,   nil,   143,   116,   nil,   116,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   319,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   331,
   nil,   nil,   nil,   nil,   nil,   nil,   352,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   361,   362,   352,   nil,
   352,   352,   352,   372,   374,   376,   nil,   nil,   nil,   nil,
   nil,   381,   nil,   352,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   393,   394,   352,   nil,   nil,   398,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   386,   nil,   389,   nil,   391,   nil,   nil,   nil,   395,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   352,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   415,   nil,   nil,   417,   418 ]

racc_goto_check = [
     2,    20,    22,    16,    53,    60,    15,    35,    64,    76,
    47,    65,    51,    49,    36,    25,    22,    61,    71,    20,
    71,    45,    55,     3,     2,    66,    66,    25,    23,    19,
    37,     1,    37,     4,    37,    19,     5,    19,     2,     2,
    23,     6,    25,    45,    55,    18,    36,     2,    36,    36,
    36,     3,     3,    17,    17,    21,    17,    24,    61,    27,
    51,    36,    13,    13,    13,    72,    72,    76,    28,    76,
    76,    76,    33,    25,    36,    38,    39,    71,    40,    25,
    25,    41,    43,    66,    44,    15,    34,    34,    34,    65,
     2,    46,    50,    54,    57,    58,    59,    63,    67,    77,
   nil,    47,   nil,   nil,    76,   nil,    36,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,     2,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    53,
   nil,   nil,    35,    64,   nil,    22,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,     2,     2,     2,     2,   nil,   nil,
    49,    60,   nil,   nil,     2,     2,     2,   nil,     2,     2,
     2,    49,   nil,    16,    16,   nil,     2,     2,   nil,     2,
    60,   nil,   nil,   nil,     2,   nil,    22,    22,    22,   nil,
   nil,   nil,   nil,   nil,     2,     2,     2,   nil,   nil,   nil,
     2,   nil,   nil,   nil,   nil,     2,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,    16,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,    22,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,    22,   nil,     2,
    15,   nil,   nil,     2,    22,   nil,    22,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,    20,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    20,
   nil,   nil,   nil,   nil,   nil,   nil,    53,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,     2,     2,    53,   nil,
    53,    53,    53,    35,    35,    35,   nil,   nil,   nil,   nil,
   nil,    20,   nil,    53,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,    20,    20,    53,   nil,   nil,    35,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
     2,   nil,     2,   nil,     2,   nil,   nil,   nil,     2,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    53,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,     2,   nil,   nil,     2,     2 ]

racc_goto_pointer = [
   nil,    31,    -2,    17,    30,    32,     7,   nil,   nil,   nil,
   nil,   nil,   nil,  -112,   nil,   -28,   -45,  -193,  -214,  -238,
   -24,  -206,   -32,  -234,  -232,  -247,   nil,  -219,  -210,   nil,
   nil,   nil,   nil,  -206,  -237,   -23,  -308,  -343,  -145,  -187,
  -200,  -240,   nil,  -284,  -298,  -376,    55,   -18,   nil,   -36,
    41,  -148,   nil,   -26,  -167,  -238,   nil,  -177,   -25,   -81,
   -48,   -29,   nil,    67,   -22,  -145,  -172,   -99,   nil,   nil,
   nil,  -178,  -134,   nil,   nil,   nil,  -134,    68 ]

racc_goto_default = [
   nil,   nil,    44,   nil,   nil,   411,   309,   107,   108,   109,
   110,   111,   112,   nil,    36,   297,   115,   nil,   nil,   nil,
   nil,   nil,    31,   nil,   276,    24,   299,   300,   301,   302,
   303,   304,   305,   308,   nil,   144,   nil,   nil,   nil,   nil,
   nil,   nil,   321,   nil,   nil,   nil,   nil,   nil,    51,   nil,
   nil,    52,   345,   145,   nil,   nil,   271,   nil,   nil,   nil,
     7,   nil,    29,   nil,   nil,   158,   146,   147,   148,   149,
   150,   151,   152,   153,   154,   155,   nil,   nil ]

racc_reduce_table = [
  0, 0, :racc_error,
  3, 82, :_reduce_1,
  3, 82, :_reduce_2,
  3, 82, :_reduce_3,
  0, 84, :_reduce_none,
  1, 84, :_reduce_none,
  0, 85, :_reduce_6,
  2, 85, :_reduce_7,
  1, 87, :_reduce_none,
  1, 87, :_reduce_none,
  1, 87, :_reduce_none,
  1, 87, :_reduce_none,
  1, 87, :_reduce_none,
  1, 87, :_reduce_none,
  0, 94, :_reduce_14,
  0, 95, :_reduce_15,
  0, 96, :_reduce_16,
  2, 96, :_reduce_17,
  8, 93, :_reduce_18,
  0, 99, :_reduce_19,
  2, 99, :_reduce_20,
  5, 99, :_reduce_21,
  8, 92, :_reduce_22,
  8, 92, :_reduce_23,
  0, 102, :_reduce_24,
  2, 102, :_reduce_25,
  1, 104, :_reduce_26,
  3, 104, :_reduce_27,
  4, 105, :_reduce_28,
  1, 105, :_reduce_29,
  0, 100, :_reduce_30,
  2, 100, :_reduce_31,
  1, 107, :_reduce_none,
  1, 107, :_reduce_none,
  1, 107, :_reduce_none,
  1, 107, :_reduce_none,
  1, 107, :_reduce_none,
  1, 107, :_reduce_none,
  1, 107, :_reduce_38,
  1, 107, :_reduce_39,
  1, 107, :_reduce_none,
  1, 107, :_reduce_none,
  0, 115, :_reduce_42,
  2, 115, :_reduce_43,
  5, 113, :_reduce_44,
  7, 113, :_reduce_45,
  5, 113, :_reduce_46,
  7, 113, :_reduce_47,
  5, 113, :_reduce_48,
  7, 113, :_reduce_49,
  0, 118, :_reduce_50,
  2, 118, :_reduce_51,
  3, 118, :_reduce_52,
  3, 112, :_reduce_53,
  3, 112, :_reduce_54,
  5, 112, :_reduce_55,
  7, 91, :_reduce_56,
  0, 120, :_reduce_57,
  2, 120, :_reduce_58,
  1, 121, :_reduce_59,
  1, 121, :_reduce_60,
  1, 121, :_reduce_none,
  3, 109, :_reduce_62,
  6, 109, :_reduce_63,
  3, 110, :_reduce_64,
  6, 110, :_reduce_65,
  3, 111, :_reduce_66,
  6, 111, :_reduce_67,
  0, 122, :_reduce_68,
  1, 122, :_reduce_69,
  7, 108, :_reduce_70,
  0, 123, :_reduce_none,
  2, 123, :_reduce_72,
  0, 124, :_reduce_73,
  2, 124, :_reduce_74,
  2, 124, :_reduce_75,
  1, 126, :_reduce_76,
  1, 126, :_reduce_77,
  3, 126, :_reduce_78,
  3, 86, :_reduce_79,
  0, 129, :_reduce_80,
  3, 129, :_reduce_81,
  3, 131, :_reduce_82,
  4, 131, :_reduce_83,
  1, 125, :_reduce_84,
  2, 125, :_reduce_85,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  2, 117, :_reduce_95,
  2, 117, :_reduce_96,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 117, :_reduce_none,
  1, 133, :_reduce_none,
  1, 133, :_reduce_none,
  1, 133, :_reduce_none,
  1, 133, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  1, 134, :_reduce_none,
  0, 98, :_reduce_137,
  3, 98, :_reduce_138,
  1, 135, :_reduce_139,
  3, 135, :_reduce_140,
  3, 136, :_reduce_141,
  0, 138, :_reduce_142,
  1, 138, :_reduce_143,
  1, 138, :_reduce_144,
  0, 137, :_reduce_145,
  1, 137, :_reduce_146,
  0, 127, :_reduce_147,
  3, 127, :_reduce_148,
  1, 139, :_reduce_149,
  3, 139, :_reduce_150,
  4, 114, :_reduce_151,
  8, 114, :_reduce_152,
  5, 88, :_reduce_153,
  3, 89, :_reduce_154,
  3, 89, :_reduce_155,
  3, 90, :_reduce_156,
  1, 83, :_reduce_none,
  3, 83, :_reduce_158,
  3, 83, :_reduce_159,
  1, 141, :_reduce_160,
  1, 141, :_reduce_161,
  1, 141, :_reduce_162,
  1, 141, :_reduce_163,
  1, 141, :_reduce_164,
  1, 141, :_reduce_165,
  1, 141, :_reduce_166,
  1, 141, :_reduce_167,
  1, 141, :_reduce_168,
  1, 141, :_reduce_169,
  1, 141, :_reduce_170,
  1, 141, :_reduce_171,
  1, 141, :_reduce_172,
  1, 141, :_reduce_173,
  1, 141, :_reduce_174,
  1, 141, :_reduce_175,
  1, 141, :_reduce_176,
  4, 141, :_reduce_177,
  2, 141, :_reduce_178,
  4, 141, :_reduce_179,
  3, 141, :_reduce_180,
  4, 141, :_reduce_181,
  2, 141, :_reduce_182,
  2, 141, :_reduce_183,
  1, 141, :_reduce_none,
  1, 101, :_reduce_185,
  3, 101, :_reduce_186,
  4, 143, :_reduce_187,
  1, 144, :_reduce_188,
  3, 144, :_reduce_189,
  3, 145, :_reduce_190,
  3, 145, :_reduce_191,
  3, 145, :_reduce_192,
  2, 145, :_reduce_193,
  3, 145, :_reduce_194,
  3, 145, :_reduce_195,
  3, 145, :_reduce_196,
  1, 146, :_reduce_none,
  2, 146, :_reduce_198,
  1, 116, :_reduce_none,
  1, 116, :_reduce_none,
  1, 116, :_reduce_none,
  1, 116, :_reduce_none,
  4, 128, :_reduce_203,
  1, 128, :_reduce_204,
  5, 132, :_reduce_205,
  2, 132, :_reduce_206,
  3, 130, :_reduce_207,
  1, 130, :_reduce_208,
  1, 130, :_reduce_none,
  3, 148, :_reduce_210,
  1, 148, :_reduce_211,
  1, 148, :_reduce_none,
  3, 150, :_reduce_213,
  1, 150, :_reduce_214,
  1, 150, :_reduce_none,
  3, 152, :_reduce_216,
  1, 152, :_reduce_217,
  1, 152, :_reduce_none,
  0, 153, :_reduce_219,
  3, 153, :_reduce_220,
  1, 153, :_reduce_221,
  3, 153, :_reduce_222,
  1, 153, :_reduce_223,
  1, 153, :_reduce_224,
  2, 147, :_reduce_225,
  3, 149, :_reduce_226,
  3, 151, :_reduce_227,
  3, 154, :_reduce_228,
  4, 155, :_reduce_229,
  3, 156, :_reduce_230,
  0, 157, :_reduce_none,
  1, 157, :_reduce_none,
  1, 157, :_reduce_none,
  1, 157, :_reduce_none,
  2, 106, :_reduce_235,
  1, 158, :_reduce_none,
  1, 158, :_reduce_none,
  1, 158, :_reduce_none,
  2, 119, :_reduce_239,
  2, 97, :_reduce_240,
  2, 140, :_reduce_241,
  0, 103, :_reduce_242,
  1, 103, :_reduce_243,
  2, 103, :_reduce_244,
  1, 103, :_reduce_245,
  1, 142, :_reduce_none,
  0, 142, :_reduce_none ]

racc_reduce_n = 248

racc_shift_n = 422

racc_token_table = {
  false => 0,
  :error => 1,
  :tUIDENT => 2,
  :tLIDENT => 3,
  :tNAMESPACE => 4,
  :tINTERFACEIDENT => 5,
  :tGLOBALIDENT => 6,
  :tLKEYWORD => 7,
  :tUKEYWORD => 8,
  :tLKEYWORD_Q_E => 9,
  :tUKEYWORD_Q_E => 10,
  :tIVAR => 11,
  :tCLASSVAR => 12,
  :tANNOTATION => 13,
  :tSTRING => 14,
  :tSYMBOL => 15,
  :tINTEGER => 16,
  :tWRITE_ATTR => 17,
  :kLPAREN => 18,
  :kRPAREN => 19,
  :kLBRACKET => 20,
  :kRBRACKET => 21,
  :kLBRACE => 22,
  :kRBRACE => 23,
  :kVOID => 24,
  :kNIL => 25,
  :kTRUE => 26,
  :kFALSE => 27,
  :kANY => 28,
  :kUNTYPED => 29,
  :kTOP => 30,
  :kBOT => 31,
  :kSELF => 32,
  :kSELFQ => 33,
  :kINSTANCE => 34,
  :kCLASS => 35,
  :kBOOL => 36,
  :kSINGLETON => 37,
  :kTYPE => 38,
  :kDEF => 39,
  :kMODULE => 40,
  :kPRIVATE => 41,
  :kPUBLIC => 42,
  :kALIAS => 43,
  :kCOLON => 44,
  :kCOLON2 => 45,
  :kCOMMA => 46,
  :kBAR => 47,
  :kAMP => 48,
  :kHAT => 49,
  :kARROW => 50,
  :kQUESTION => 51,
  :kEXCLAMATION => 52,
  :kSTAR => 53,
  :kSTAR2 => 54,
  :kFATARROW => 55,
  :kEQ => 56,
  :kDOT => 57,
  :kDOT3 => 58,
  :kLT => 59,
  :kINTERFACE => 60,
  :kEND => 61,
  :kINCLUDE => 62,
  :kEXTEND => 63,
  :kATTRREADER => 64,
  :kATTRWRITER => 65,
  :kATTRACCESSOR => 66,
  :tOPERATOR => 67,
  :tQUOTEDMETHOD => 68,
  :tQUOTEDIDENT => 69,
  :kPREPEND => 70,
  :kEXTENSION => 71,
  :kINCOMPATIBLE => 72,
  :type_TYPE => 73,
  :type_SIGNATURE => 74,
  :type_METHODTYPE => 75,
  :tEOF => 76,
  :kOUT => 77,
  :kIN => 78,
  :kUNCHECKED => 79,
  :kOVERLOAD => 80 }

racc_nt_base = 81

racc_use_result_var = true

Racc_arg = [
  racc_action_table,
  racc_action_check,
  racc_action_default,
  racc_action_pointer,
  racc_goto_table,
  racc_goto_check,
  racc_goto_default,
  racc_goto_pointer,
  racc_nt_base,
  racc_reduce_table,
  racc_token_table,
  racc_shift_n,
  racc_reduce_n,
  racc_use_result_var ]

Racc_token_to_s_table = [
  "$end",
  "error",
  "tUIDENT",
  "tLIDENT",
  "tNAMESPACE",
  "tINTERFACEIDENT",
  "tGLOBALIDENT",
  "tLKEYWORD",
  "tUKEYWORD",
  "tLKEYWORD_Q_E",
  "tUKEYWORD_Q_E",
  "tIVAR",
  "tCLASSVAR",
  "tANNOTATION",
  "tSTRING",
  "tSYMBOL",
  "tINTEGER",
  "tWRITE_ATTR",
  "kLPAREN",
  "kRPAREN",
  "kLBRACKET",
  "kRBRACKET",
  "kLBRACE",
  "kRBRACE",
  "kVOID",
  "kNIL",
  "kTRUE",
  "kFALSE",
  "kANY",
  "kUNTYPED",
  "kTOP",
  "kBOT",
  "kSELF",
  "kSELFQ",
  "kINSTANCE",
  "kCLASS",
  "kBOOL",
  "kSINGLETON",
  "kTYPE",
  "kDEF",
  "kMODULE",
  "kPRIVATE",
  "kPUBLIC",
  "kALIAS",
  "kCOLON",
  "kCOLON2",
  "kCOMMA",
  "kBAR",
  "kAMP",
  "kHAT",
  "kARROW",
  "kQUESTION",
  "kEXCLAMATION",
  "kSTAR",
  "kSTAR2",
  "kFATARROW",
  "kEQ",
  "kDOT",
  "kDOT3",
  "kLT",
  "kINTERFACE",
  "kEND",
  "kINCLUDE",
  "kEXTEND",
  "kATTRREADER",
  "kATTRWRITER",
  "kATTRACCESSOR",
  "tOPERATOR",
  "tQUOTEDMETHOD",
  "tQUOTEDIDENT",
  "kPREPEND",
  "kEXTENSION",
  "kINCOMPATIBLE",
  "type_TYPE",
  "type_SIGNATURE",
  "type_METHODTYPE",
  "tEOF",
  "kOUT",
  "kIN",
  "kUNCHECKED",
  "kOVERLOAD",
  "$start",
  "target",
  "type",
  "eof",
  "signatures",
  "method_type",
  "signature",
  "type_decl",
  "const_decl",
  "global_decl",
  "interface_decl",
  "module_decl",
  "class_decl",
  "start_new_scope",
  "start_merged_scope",
  "annotations",
  "class_name",
  "module_type_params",
  "super_class",
  "class_members",
  "type_list",
  "colon_module_self_types",
  "namespace",
  "module_self_types",
  "module_self_type",
  "qualified_name",
  "class_member",
  "method_member",
  "include_member",
  "extend_member",
  "prepend_member",
  "var_type_member",
  "attribute_member",
  "alias_member",
  "attribute_kind",
  "keyword",
  "method_name",
  "attr_var_opt",
  "interface_name",
  "interface_members",
  "interface_member",
  "overload",
  "attributes",
  "method_kind",
  "def_name",
  "method_types",
  "type_params",
  "proc_type",
  "params_opt",
  "params",
  "block",
  "simple_function_type",
  "method_name0",
  "identifier_keywords",
  "module_type_params0",
  "module_type_param",
  "type_param_check",
  "type_param_variance",
  "type_params0",
  "type_alias_name",
  "simple_type",
  "comma_opt",
  "record_type",
  "record_fields",
  "record_field",
  "keyword_name",
  "required_positional",
  "optional_positional_params",
  "optional_positional",
  "rest_positional_param",
  "rest_positional",
  "trailing_positional_params",
  "keyword_params",
  "required_keyword",
  "optional_keyword",
  "rest_keyword",
  "var_name_opt",
  "simple_name" ]

Racc_debug_parser = false

##### State transition tables end #####

# reduce 0 omitted

module_eval(<<'.,.,', 'parser.y', 28)
  def _reduce_1(val, _values, result)
            result = val[1]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 31)
  def _reduce_2(val, _values, result)
            result = val[1]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 34)
  def _reduce_3(val, _values, result)
            result = val[1]

    result
  end
.,.,

# reduce 4 omitted

# reduce 5 omitted

module_eval(<<'.,.,', 'parser.y', 40)
  def _reduce_6(val, _values, result)
     result = []
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 42)
  def _reduce_7(val, _values, result)
            result = val[0].push(val[1])

    result
  end
.,.,

# reduce 8 omitted

# reduce 9 omitted

# reduce 10 omitted

# reduce 11 omitted

# reduce 12 omitted

# reduce 13 omitted

module_eval(<<'.,.,', 'parser.y', 53)
  def _reduce_14(val, _values, result)
     start_new_variables_scope
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 54)
  def _reduce_15(val, _values, result)
     start_merged_variables_scope
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 57)
  def _reduce_16(val, _values, result)
     result = []
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 59)
  def _reduce_17(val, _values, result)
            result = val[1].unshift(Annotation.new(string: val[0].value, location: val[0].location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 64)
  def _reduce_18(val, _values, result)
            reset_variable_scope

        location = val[1].location + val[7].location
        location = location.with_children(
          required: {
            keyword: val[1].location,
            name: val[3].location,
            end: val[7].location
          },
          optional: {
            type_params: val[4]&.location,
            lt: val[5]&.location
          }
        )
        result = Declarations::Class.new(
          name: val[3].value,
          type_params: val[4]&.value || Declarations::ModuleTypeParams.empty,
          super_class: val[5]&.value,
          members: val[6],
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 90)
  def _reduce_19(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 92)
  def _reduce_20(val, _values, result)
            loc = val[1].location.with_children(
          required: { name: val[1].location },
          optional: { args: nil }
        )
        sup = Declarations::Class::Super.new(name: val[1].value, args: [], location: loc)
        result = LocatedValue.new(value: sup, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 100)
  def _reduce_21(val, _values, result)
            loc = (val[1].location + val[4].location).with_children(
          required: { name: val[1].location },
          optional: { args: val[2].location + val[4].location }
        )
        sup = Declarations::Class::Super.new(name: val[1].value, args: val[3], location: loc)
        result = LocatedValue.new(value: sup, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 110)
  def _reduce_22(val, _values, result)
            reset_variable_scope

        colon_loc = val[5].location
        self_loc = val[5].value.yield_self do |params|
          case params.size
          when 0
            nil
          when 1
            params[0].location
          else
            params.first.location + params.last.location
          end
        end

        location = val[1].location + val[7].location
        location = location.with_children(
          required: {
            keyword: val[1].location,
            name: val[3].location,
            end: val[7].location
          },
          optional: {
            type_params: val[4]&.location,
            colon: colon_loc,
            self_types: self_loc
          }
        )
        result = Declarations::Module.new(
          name: val[3].value,
          type_params: val[4]&.value || Declarations::ModuleTypeParams.empty,
          self_types: val[5].value,
          members: val[6],
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 148)
  def _reduce_23(val, _values, result)
            reset_variable_scope

        location = val[1].location + val[7].location
        name_loc, colon_loc = split_kw_loc(val[4].location)
        self_loc = case val[5].size
                   when 0
                     nil
                   when 1
                     val[5][0].location
                   else
                     val[5].first.location + val[5].last.location
                   end
        location = location.with_children(
          required: { keyword: val[1].location, name: name_loc, end: val[7].location },
          optional: { colon: colon_loc, type_params: nil, self_types: self_loc }
        )

        result = Declarations::Module.new(
          name: RBS::TypeName.new(name: val[4].value, namespace: val[3]&.value || RBS::Namespace.empty),
          type_params: Declarations::ModuleTypeParams.empty,
          self_types: val[5],
          members: val[6],
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 177)
  def _reduce_24(val, _values, result)
     result = LocatedValue.new(value: [], location: nil)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 179)
  def _reduce_25(val, _values, result)
            result = LocatedValue.new(value: val[1], location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 184)
  def _reduce_26(val, _values, result)
            result = [val[0]]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 187)
  def _reduce_27(val, _values, result)
            result = val[0].push(val[2])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 192)
  def _reduce_28(val, _values, result)
            name = val[0].value
        args = val[2]
        location = val[0].location + val[3].location
        location = location.with_children(
          required: { name: val[0].location },
          optional: { args: val[1].location + val[3].location }
        )

        case
        when name.class?
          result = Declarations::Module::Self.new(name: name, args: args, location: location)
        when name.interface?
          result = Declarations::Module::Self.new(name: name, args: args, location: location)
        else
          raise SemanticsError.new("Module self type should be instance or interface", subject: val[0], location: val[0].location)
        end

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 210)
  def _reduce_29(val, _values, result)
            name = val[0].value
        args = []
        location = val[0].location.with_children(
          required: { name: val[0].location },
          optional: { args: nil }
        )

        case
        when name.class?
          result = Declarations::Module::Self.new(name: name, args: args, location: location)
        when name.interface?
          result = Declarations::Module::Self.new(name: name, args: args, location: location)
        else
          raise SemanticsError.new("Module self type should be instance or interface", subject: val[0], location: val[0].location)
        end

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 228)
  def _reduce_30(val, _values, result)
     result = []
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 230)
  def _reduce_31(val, _values, result)
            result = val[0].push(val[1])

    result
  end
.,.,

# reduce 32 omitted

# reduce 33 omitted

# reduce 34 omitted

# reduce 35 omitted

# reduce 36 omitted

# reduce 37 omitted

module_eval(<<'.,.,', 'parser.y', 241)
  def _reduce_38(val, _values, result)
            result = Members::Public.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 244)
  def _reduce_39(val, _values, result)
            result = Members::Private.new(location: val[0].location)

    result
  end
.,.,

# reduce 40 omitted

# reduce 41 omitted

module_eval(<<'.,.,', 'parser.y', 250)
  def _reduce_42(val, _values, result)
     result = LocatedValue.new(value: :instance, location: nil)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 251)
  def _reduce_43(val, _values, result)
     result = LocatedValue.new(value: :singleton, location: val[0].location + val[1].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 255)
  def _reduce_44(val, _values, result)
            location = val[1].location + val[4].location
        name_loc, colon_loc = split_kw_loc(val[3].location)
        location = location.with_children(
          required: { keyword: val[1].location, name: name_loc, colon: colon_loc },
          optional: { ivar: nil, ivar_name: nil, kind: val[2].location }
        )
        result = Members::AttrReader.new(name: val[3].value,
                                         ivar_name: nil,
                                         type: val[4],
                                         kind: val[2].value,
                                         annotations: val[0],
                                         location: location,
                                         comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 270)
  def _reduce_45(val, _values, result)
            location = val[1].location + val[6].location
        ivar_loc = val[4]&.location
        case name_value = val[4]&.value
        when LocatedValue
          ivar_name = name_value.value
          ivar_name_loc = name_value.location
        when false
          ivar_name = false
          ivar_name_loc = nil
        else
          ivar_name = nil
          ivar_loc = nil
        end
        location = location.with_children(
          required: { keyword: val[1].location, name: val[3].location, colon: val[5].location },
          optional: { ivar: ivar_loc, ivar_name: ivar_name_loc, kind: val[2].location }
        )
        result = Members::AttrReader.new(name: val[3].value.to_sym,
                                         ivar_name: ivar_name,
                                         type: val[6],
                                         kind: val[2].value,
                                         annotations: val[0],
                                         location: location,
                                         comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 296)
  def _reduce_46(val, _values, result)
            location = val[1].location + val[4].location
        name_loc, colon_loc = split_kw_loc(val[3].location)
        location = location.with_children(
          required: { keyword: val[1].location, name: name_loc, colon: colon_loc },
          optional: { ivar: nil, ivar_name: nil, kind: val[2].location }
        )
        result = Members::AttrWriter.new(name: val[3].value,
                                         ivar_name: nil,
                                         kind: val[2].value,
                                         type: val[4],
                                         annotations: val[0],
                                         location: location,
                                         comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 311)
  def _reduce_47(val, _values, result)
            location = val[1].location + val[6].location
        ivar_loc = val[4]&.location
        case name_value = val[4]&.value
        when LocatedValue
          ivar_name = name_value.value
          ivar_name_loc = name_value.location
        when false
          ivar_name = false
          ivar_name_loc = nil
        else
          ivar_name = nil
          ivar_loc = nil
        end
        location = location.with_children(
          required: { keyword: val[1].location, name: val[3].location, colon: val[5].location },
          optional: { ivar: ivar_loc, ivar_name: ivar_name_loc, kind: val[2].location }
        )

        result = Members::AttrWriter.new(name: val[3].value.to_sym,
                                         ivar_name: ivar_name,
                                         kind: val[2].value,
                                         type: val[6],
                                         annotations: val[0],
                                         location: location,
                                         comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 338)
  def _reduce_48(val, _values, result)
            location = val[1].location + val[4].location
        name_loc, colon_loc = split_kw_loc(val[3].location)
        location = location.with_children(
          required: { keyword: val[1].location, name: name_loc, colon: colon_loc },
          optional: { ivar: nil, ivar_name: nil, kind: val[2].location }
        )

        result = Members::AttrAccessor.new(name: val[3].value,
                                           ivar_name: nil,
                                           kind: val[2].value,
                                           type: val[4],
                                           annotations: val[0],
                                           location: location,
                                           comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 354)
  def _reduce_49(val, _values, result)
            location = val[1].location + val[6].location
        ivar_loc = val[4]&.location
        case name_value = val[4]&.value
        when LocatedValue
          ivar_name = name_value.value
          ivar_name_loc = name_value.location
        when false
          ivar_name = false
          ivar_name_loc = nil
        else
          ivar_name = nil
          ivar_loc = nil
        end
        location = location.with_children(
          required: { keyword: val[1].location, name: val[3].location, colon: val[5].location },
          optional: { ivar: ivar_loc, ivar_name: ivar_name_loc, kind: val[2].location }
        )

        result = Members::AttrAccessor.new(name: val[3].value.to_sym,
                                           ivar_name: ivar_name,
                                           kind: val[2].value,
                                           type: val[6],
                                           annotations: val[0],
                                           location: location,
                                           comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 382)
  def _reduce_50(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 383)
  def _reduce_51(val, _values, result)
     result = LocatedValue.new(value: false, location: val[0].location + val[1].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 385)
  def _reduce_52(val, _values, result)
            result = LocatedValue.new(
          value: val[1],
          location: val[0].location + val[2].location
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 393)
  def _reduce_53(val, _values, result)
            location = (val[0].location + val[2].location).with_children(
          required: { name: val[0].location, colon: val[1].location },
          optional: { kind: nil }
        )

        result = Members::InstanceVariable.new(
          name: val[0].value,
          type: val[2],
          location: location,
          comment: leading_comment(location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 406)
  def _reduce_54(val, _values, result)
            type = val[2]

        if type.is_a?(Types::Variable)
          type = Types::ClassInstance.new(
            name: TypeName.new(name: type.name, namespace: Namespace.empty),
            args: [],
            location: type.location
          )
        end

        location = (val[0].location + val[2].location).with_children(
          required: { name: val[0].location, colon: val[1].location },
          optional: { kind: nil }
        )

        result = Members::ClassVariable.new(
          name: val[0].value,
          type: type,
          location: location,
          comment: leading_comment(location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 429)
  def _reduce_55(val, _values, result)
          type = val[4]

      if type.is_a?(Types::Variable)
        type = Types::ClassInstance.new(
          name: TypeName.new(name: type.name, namespace: Namespace.empty),
          args: [],
          location: type.location
        )
      end

      location = (val[0].location + val[4].location).with_children(
        required: { name: val[2].location, colon: val[3].location },
        optional: { kind: val[0].location + val[1].location }
      )

      result = Members::ClassInstanceVariable.new(
        name: val[2].value,
        type: type,
        location: location,
        comment: leading_comment(location)
      )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 454)
  def _reduce_56(val, _values, result)
            reset_variable_scope

        location = val[1].location + val[6].location
        location = location.with_children(
          required: { keyword: val[1].location, name: val[3].location, end: val[6].location },
          optional: { type_params: val[4]&.location }
        )
        result = Declarations::Interface.new(
          name: val[3].value,
          type_params: val[4]&.value || Declarations::ModuleTypeParams.empty,
          members: val[5],
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 472)
  def _reduce_57(val, _values, result)
     result = []
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 474)
  def _reduce_58(val, _values, result)
            result = val[0].push(val[1])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 479)
  def _reduce_59(val, _values, result)
            unless val[0].kind == :instance
          raise SemanticsError.new("Interface cannot have singleton method", subject: val[0], location: val[0].location)
        end

        if val[0].types.last == :super
          raise SemanticsError.new("Interface method cannot have `super` type", subject: val[0], location: val[0].location)
        end

        result = val[0]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 490)
  def _reduce_60(val, _values, result)
            unless val[0].name.interface?
          raise SemanticsError.new("Interface should include an interface", subject: val[0], location: val[0].location)
        end

        result = val[0]

    result
  end
.,.,

# reduce 61 omitted

module_eval(<<'.,.,', 'parser.y', 500)
  def _reduce_62(val, _values, result)
            if val[2].value.alias?
          raise SemanticsError.new("Should include module or interface", subject: val[2].value, location: val[2].location)
        end

        location = (val[1].location + val[2].location).with_children(
          required: { keyword: val[1].location, name: val[2].location },
          optional: { args: nil }
        )

        result = Members::Include.new(name: val[2].value,
                                      args: [],
                                      annotations: val[0],
                                      location: location,
                                      comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 516)
  def _reduce_63(val, _values, result)
            if val[2].value.alias?
          raise SemanticsError.new("Should include module or interface", subject: val[2].value, location: val[2].location)
        end

        location = (val[1].location + val[5].location).with_children(
          required: { keyword: val[1].location, name: val[2].location },
          optional: { args: val[3].location + val[5].location }
        )

        result = Members::Include.new(name: val[2].value,
                                      args: val[4],
                                      annotations: val[0],
                                      location: location,
                                      comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 534)
  def _reduce_64(val, _values, result)
            if val[2].value.alias?
          raise SemanticsError.new("Should extend module or interface", subject: val[2].value, location: val[2].location)
        end

        location = (val[1].location + val[2].location).with_children(
          required: { keyword: val[1].location, name: val[2].location },
          optional: { args: nil }
        )

        result = Members::Extend.new(name: val[2].value,
                                     args: [],
                                     annotations: val[0],
                                     location: location,
                                     comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 550)
  def _reduce_65(val, _values, result)
            if val[2].value.alias?
          raise SemanticsError.new("Should extend module or interface", subject: val[2].value, location: val[2].location)
        end

        location = (val[1].location + val[5].location).with_children(
          required: { keyword: val[1].location, name: val[2].location },
          optional: { args: val[3].location + val[5].location }
        )

        result = Members::Extend.new(name: val[2].value,
                                     args: val[4],
                                     annotations: val[0],
                                     location: location,
                                     comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 568)
  def _reduce_66(val, _values, result)
            unless val[2].value.class?
          raise SemanticsError.new("Should prepend module", subject: val[2].value, location: val[2].location)
        end

        location = (val[1].location + val[2].location).with_children(
          required: { keyword: val[1].location, name: val[2].location },
          optional: { args: nil }
        )

        result = Members::Prepend.new(name: val[2].value,
                                      args: [],
                                      annotations: val[0],
                                      location: location,
                                      comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 584)
  def _reduce_67(val, _values, result)
            unless val[2].value.class?
          raise SemanticsError.new("Should prepend module", subject: val[2].value, location: val[2].location)
        end

        location = (val[1].location + val[5].location).with_children(
          required: { keyword: val[1].location, name: val[2].location },
          optional: { args: val[3].location + val[5].location }
        )

        result = Members::Prepend.new(name: val[2].value,
                                      args: val[4],
                                      annotations: val[0],
                                      location: location,
                                      comment: leading_comment(val[0].first&.location || location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 601)
  def _reduce_68(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 603)
  def _reduce_69(val, _values, result)
            RBS.logger.warn "`overload def` syntax is deprecated. Use `...` syntax instead."
        result = val[0]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 609)
  def _reduce_70(val, _values, result)
            location = val[3].location + val[6].last.location
        children = {}

        required_children = { keyword: val[3].location, name: val[5].location }
        optional_children = { kind: nil, overload: nil }

        if val[4]
          kind = val[4].value
          optional_children[:kind] = val[4].location
        else
          kind = :instance
        end

        last_type = val[6].last
        if last_type.is_a?(LocatedValue) && last_type.value == :dot3
          overload = true
          optional_children[:overload] = last_type.location
          val[6].pop
        else
          overload = false
        end

        result = Members::MethodDefinition.new(
          name: val[5].value,
          kind: kind,
          types: val[6],
          annotations: val[0],
          location: location.with_children(required: required_children, optional: optional_children),
          comment: leading_comment(val[0].first&.location || val[2]&.location || val[3].location),
          overload: overload || !!val[2]
        )

    result
  end
.,.,

# reduce 71 omitted

module_eval(<<'.,.,', 'parser.y', 644)
  def _reduce_72(val, _values, result)
            RBS.logger.warn "`incompatible` method attribute is deprecated and ignored."

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 648)
  def _reduce_73(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 649)
  def _reduce_74(val, _values, result)
     result = LocatedValue.new(value: :singleton, location: val[0].location + val[1].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 650)
  def _reduce_75(val, _values, result)
     result = LocatedValue.new(value: :singleton_instance, location: val[0].location + val[1].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 653)
  def _reduce_76(val, _values, result)
     result = [val[0]]
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 654)
  def _reduce_77(val, _values, result)
     result = [LocatedValue.new(value: :dot3, location: val[0].location)]
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 656)
  def _reduce_78(val, _values, result)
            result = val[2].unshift(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 661)
  def _reduce_79(val, _values, result)
            reset_variable_scope

        location = (val[1] || val[2]).location + val[2].location
        type_params = val[1]&.value || []

        type, block = val[2].value

        result = MethodType.new(type_params: type_params,
                                type: type,
                                block: block,
                                location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 675)
  def _reduce_80(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 677)
  def _reduce_81(val, _values, result)
            result = LocatedValue.new(value: val[1], location: val[0].location + val[2].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 682)
  def _reduce_82(val, _values, result)
            block = Types::Block.new(type: val[1].value, required: true)
        result = LocatedValue.new(value: block, location: val[0].location + val[2].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 686)
  def _reduce_83(val, _values, result)
            block = Types::Block.new(type: val[2].value, required: false)
        result = LocatedValue.new(value: block, location: val[0].location + val[3].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 692)
  def _reduce_84(val, _values, result)
            loc = val[0].location

        result = LocatedValue.new(
          value: val[0].value,
          location: Location.new(buffer: loc.buffer, start_pos: loc.start_pos, end_pos: loc.end_pos - 1)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 700)
  def _reduce_85(val, _values, result)
            result = LocatedValue.new(value: val[0].value.to_sym,
                                  location: val[0].location + val[1].location)

    result
  end
.,.,

# reduce 86 omitted

# reduce 87 omitted

# reduce 88 omitted

# reduce 89 omitted

# reduce 90 omitted

# reduce 91 omitted

# reduce 92 omitted

# reduce 93 omitted

# reduce 94 omitted

module_eval(<<'.,.,', 'parser.y', 709)
  def _reduce_95(val, _values, result)
            unless val[0].location.pred?(val[1].location)
          raise SyntaxError.new(token_str: "kQUESTION", error_value: val[1])
        end

        result = LocatedValue.new(value: "#{val[0].value}?",
                                  location: val[0].location + val[1].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 717)
  def _reduce_96(val, _values, result)
            unless val[0].location.pred?(val[1].location)
          raise SyntaxError.new(token_str: "kEXCLAMATION", error_value: val[1])
        end

        result = LocatedValue.new(value: "#{val[0].value}!",
                                  location: val[0].location + val[1].location)

    result
  end
.,.,

# reduce 97 omitted

# reduce 98 omitted

# reduce 99 omitted

# reduce 100 omitted

# reduce 101 omitted

# reduce 102 omitted

# reduce 103 omitted

# reduce 104 omitted

# reduce 105 omitted

# reduce 106 omitted

# reduce 107 omitted

# reduce 108 omitted

# reduce 109 omitted

# reduce 110 omitted

# reduce 111 omitted

# reduce 112 omitted

# reduce 113 omitted

# reduce 114 omitted

# reduce 115 omitted

# reduce 116 omitted

# reduce 117 omitted

# reduce 118 omitted

# reduce 119 omitted

# reduce 120 omitted

# reduce 121 omitted

# reduce 122 omitted

# reduce 123 omitted

# reduce 124 omitted

# reduce 125 omitted

# reduce 126 omitted

# reduce 127 omitted

# reduce 128 omitted

# reduce 129 omitted

# reduce 130 omitted

# reduce 131 omitted

# reduce 132 omitted

# reduce 133 omitted

# reduce 134 omitted

# reduce 135 omitted

# reduce 136 omitted

module_eval(<<'.,.,', 'parser.y', 737)
  def _reduce_137(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 739)
  def _reduce_138(val, _values, result)
            val[1].each {|p| insert_bound_variable(p.name) }

        result = LocatedValue.new(value: val[1], location: val[0].location + val[2].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 746)
  def _reduce_139(val, _values, result)
            result = Declarations::ModuleTypeParams.new()
        result.add(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 750)
  def _reduce_140(val, _values, result)
            result = val[0].add(val[2])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 755)
  def _reduce_141(val, _values, result)
            loc = case
              when l0 = val[0].location
                l0 + val[2].location
              when l1 = val[1].location
                l1 + val[2].location
              else
                val[2].location
              end
        loc = loc.with_children(
          required: { name: val[2].location },
          optional: { variance: val[1].location, unchecked: val[0].location }
        )
        result = Declarations::ModuleTypeParams::TypeParam.new(
          name: val[2].value.to_sym,
          variance: val[1].value,
          skip_validation: val[0].value,
          location: loc
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 776)
  def _reduce_142(val, _values, result)
     result = LocatedValue.new(value: :invariant, location: nil)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 777)
  def _reduce_143(val, _values, result)
     result = LocatedValue.new(value: :covariant, location: val[0].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 778)
  def _reduce_144(val, _values, result)
     result = LocatedValue.new(value: :contravariant, location: val[0].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 781)
  def _reduce_145(val, _values, result)
     result = LocatedValue.new(value: false, location: nil)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 782)
  def _reduce_146(val, _values, result)
     result = LocatedValue.new(value: true, location: val[0].location)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 785)
  def _reduce_147(val, _values, result)
     result = nil
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 787)
  def _reduce_148(val, _values, result)
            val[1].each {|var| insert_bound_variable(var) }

        result = LocatedValue.new(value: val[1],
                                  location: val[0].location + val[2].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 795)
  def _reduce_149(val, _values, result)
            result = [val[0].value.to_sym]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 798)
  def _reduce_150(val, _values, result)
            result = val[0].push(val[2].value.to_sym)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 803)
  def _reduce_151(val, _values, result)
            location = val[1].location + val[3].location
        location = location.with_children(
          required: { keyword: val[1].location, new_name: val[2].location, old_name: val[3].location },
          optional: { new_kind: nil, old_kind: nil }
        )
        result = Members::Alias.new(
          new_name: val[2].value.to_sym,
          old_name: val[3].value.to_sym,
          kind: :instance,
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 818)
  def _reduce_152(val, _values, result)
            location = val[1].location + val[7].location
        location = location.with_children(
          required: { keyword: val[1].location, new_name: val[4].location, old_name: val[7].location },
          optional: {
            new_kind: val[2].location + val[3].location,
            old_kind: val[5].location + val[6].location
          }
        )
        result = Members::Alias.new(
          new_name: val[4].value.to_sym,
          old_name: val[7].value.to_sym,
          kind: :singleton,
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 838)
  def _reduce_153(val, _values, result)
            location = val[1].location + val[4].location
        location = location.with_children(
          required: { keyword: val[1].location, name: val[2].location, eq: val[3].location }
        )
        result = Declarations::Alias.new(
          name: val[2].value,
          type: val[4],
          annotations: val[0],
          location: location,
          comment: leading_comment(val[0].first&.location || location)
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 853)
  def _reduce_154(val, _values, result)
            location = val[0].location + val[2].location
        location = location.with_children(
          required: { name: val[0].location, colon: val[1].location }
        )
        result = Declarations::Constant.new(name: val[0].value,
                                            type: val[2],
                                            location: location,
                                            comment: leading_comment(location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 863)
  def _reduce_155(val, _values, result)
            location = (val[0] || val[1]).location + val[2].location

        lhs_loc = (val[0] || val[1]).location + val[1].location
        name_loc, colon_loc = split_kw_loc(lhs_loc)
        location = location.with_children(
          required: { name: name_loc, colon: colon_loc }
        )

        name = TypeName.new(name: val[1].value, namespace: val[0]&.value || Namespace.empty)
        result = Declarations::Constant.new(name: name,
                                            type: val[2],
                                            location: location,
                                            comment: leading_comment(location))

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 880)
  def _reduce_156(val, _values, result)
            location = val[0].location + val[2].location
        location = location.with_children(
          required: { name: val[0].location, colon: val[1].location }
        )
        result = Declarations::Global.new(name: val[0].value.to_sym,
                                          type: val[2],
                                          location: location,
                                          comment: leading_comment(location))

    result
  end
.,.,

# reduce 157 omitted

module_eval(<<'.,.,', 'parser.y', 893)
  def _reduce_158(val, _values, result)
            types = case l = val[0]
                when Types::Union
                  l.types + [val[2]]
                else
                  [l, val[2]]
                end

        result = Types::Union.new(types: types, location: val[0].location + val[2].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 903)
  def _reduce_159(val, _values, result)
            types = case l = val[0]
                when Types::Intersection
                  l.types + [val[2]]
                else
                  [l, val[2]]
                end

        result = Types::Intersection.new(types: types,
                                         location: val[0].location + val[2].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 916)
  def _reduce_160(val, _values, result)
            result = Types::Bases::Void.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 919)
  def _reduce_161(val, _values, result)
            RBS.logger.warn "`any` type is deprecated. Use `untyped` instead. (#{val[0].location.to_s})"
        result = Types::Bases::Any.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 923)
  def _reduce_162(val, _values, result)
            result = Types::Bases::Any.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 926)
  def _reduce_163(val, _values, result)
            result = Types::Bases::Bool.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 929)
  def _reduce_164(val, _values, result)
            result = Types::Bases::Nil.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 932)
  def _reduce_165(val, _values, result)
            result = Types::Bases::Top.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 935)
  def _reduce_166(val, _values, result)
            result = Types::Bases::Bottom.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 938)
  def _reduce_167(val, _values, result)
            result = Types::Bases::Self.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 941)
  def _reduce_168(val, _values, result)
            result = Types::Optional.new(type: Types::Bases::Self.new(location: val[0].location),
                                     location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 945)
  def _reduce_169(val, _values, result)
            result = Types::Bases::Instance.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 948)
  def _reduce_170(val, _values, result)
            result = Types::Bases::Class.new(location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 951)
  def _reduce_171(val, _values, result)
            result = Types::Literal.new(literal: true, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 954)
  def _reduce_172(val, _values, result)
            result = Types::Literal.new(literal: false, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 957)
  def _reduce_173(val, _values, result)
            result = Types::Literal.new(literal: val[0].value, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 960)
  def _reduce_174(val, _values, result)
            result = Types::Literal.new(literal: val[0].value, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 963)
  def _reduce_175(val, _values, result)
            result = Types::Literal.new(literal: val[0].value, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 966)
  def _reduce_176(val, _values, result)
            name = val[0].value
        args = []
        location = val[0].location

        case
        when name.class?
          if is_bound_variable?(name.name)
            result = Types::Variable.new(name: name.name, location: location)
          else
            location = location.with_children(
              required: { name: val[0].location },
              optional: { args: nil }
            )
            result = Types::ClassInstance.new(name: name, args: args, location: location)
          end
        when name.alias?
          location = location.with_children(
            required: { name: val[0].location },
            optional: { args: nil }
          )
          result = Types::Alias.new(name: name, location: location)
        when name.interface?
          location = location.with_children(
            required: { name: val[0].location },
            optional: { args: nil }
          )
          result = Types::Interface.new(name: name, args: args, location: location)
        end

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 996)
  def _reduce_177(val, _values, result)
            name = val[0].value
        args = val[2]
        location = val[0].location + val[3].location

        case
        when name.class?
          if is_bound_variable?(name.name)
            raise SemanticsError.new("#{name.name} is type variable and cannot be applied", subject: name, location: location)
          end
          location = location.with_children(
            required: { name: val[0].location },
            optional: { args: val[1].location + val[3].location }
          )
          result = Types::ClassInstance.new(name: name, args: args, location: location)
        when name.interface?
          location = location.with_children(
            required: { name: val[0].location },
            optional: { args: val[1].location + val[3].location }
          )
          result = Types::Interface.new(name: name, args: args, location: location)
        else
          raise SyntaxError.new(token_str: "kLBRACKET", error_value: val[1])
        end

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1021)
  def _reduce_178(val, _values, result)
            location = val[0].location + val[1].location
        result = Types::Tuple.new(types: [], location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1025)
  def _reduce_179(val, _values, result)
            location = val[0].location + val[3].location
        types = val[1]
        result = Types::Tuple.new(types: types, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1030)
  def _reduce_180(val, _values, result)
            type = val[1].dup
        type.instance_eval do
          @location = val[0].location + val[2].location
        end
        result = type

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1037)
  def _reduce_181(val, _values, result)
            location = val[0].location + val[3].location
        location = location.with_children(
          required: { name: val[2].location }
        )
        result = Types::ClassSingleton.new(name: val[2].value, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1044)
  def _reduce_182(val, _values, result)
            type, block = val[1].value
        result = Types::Proc.new(type: type, block: block, location: val[0].location + val[1].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1048)
  def _reduce_183(val, _values, result)
            result = Types::Optional.new(type: val[0], location: val[0].location + val[1].location)

    result
  end
.,.,

# reduce 184 omitted

module_eval(<<'.,.,', 'parser.y', 1054)
  def _reduce_185(val, _values, result)
            result = [val[0]]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1057)
  def _reduce_186(val, _values, result)
            result = val[0] + [val[2]]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1062)
  def _reduce_187(val, _values, result)
            result = Types::Record.new(
          fields: val[1],
          location: val[0].location + val[3].location
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1070)
  def _reduce_188(val, _values, result)
            result = val[0]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1073)
  def _reduce_189(val, _values, result)
            result = val[0].merge!(val[2])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1078)
  def _reduce_190(val, _values, result)
            result = { val[0].value => val[2] }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1081)
  def _reduce_191(val, _values, result)
            result = { val[0].value => val[2] }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1084)
  def _reduce_192(val, _values, result)
            result = { val[0].value => val[2] }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1087)
  def _reduce_193(val, _values, result)
            result = { val[0].value => val[1] }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1090)
  def _reduce_194(val, _values, result)
            result = { val[0].value => val[2] }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1093)
  def _reduce_195(val, _values, result)
            result = { val[0].value => val[2] }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1096)
  def _reduce_196(val, _values, result)
            result = { val[0].value => val[2] }

    result
  end
.,.,

# reduce 197 omitted

module_eval(<<'.,.,', 'parser.y', 1102)
  def _reduce_198(val, _values, result)
            result = val[0]

    result
  end
.,.,

# reduce 199 omitted

# reduce 200 omitted

# reduce 201 omitted

# reduce 202 omitted

module_eval(<<'.,.,', 'parser.y', 1109)
  def _reduce_203(val, _values, result)
            location = (val[0] || val[1] || val[2]).location + val[3].location

        params = val[0]&.value || [[], [], nil, [], {}, {}, nil]

        type = Types::Function.new(
          required_positionals: params[0],
          optional_positionals: params[1],
          rest_positionals: params[2],
          trailing_positionals: params[3],
          required_keywords: params[4],
          optional_keywords: params[5],
          rest_keywords: params[6],
          return_type: val[3]
        )

        block = val[1].value

        result = LocatedValue.new(value: [type, block], location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1129)
  def _reduce_204(val, _values, result)
            result = LocatedValue.new(value: [val[0].value, nil], location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1134)
  def _reduce_205(val, _values, result)
            location = val[0].location + val[4].location
        type = Types::Function.new(
          required_positionals: val[1][0],
          optional_positionals: val[1][1],
          rest_positionals: val[1][2],
          trailing_positionals: val[1][3],
          required_keywords: val[1][4],
          optional_keywords: val[1][5],
          rest_keywords: val[1][6],
          return_type: val[4],
        )

        result = LocatedValue.new(value: type, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1149)
  def _reduce_206(val, _values, result)
            location = val[0].location + val[1].location
        type = Types::Function.new(
          required_positionals: [],
          optional_positionals: [],
          rest_positionals: nil,
          trailing_positionals: [],
          required_keywords: {},
          optional_keywords: {},
          rest_keywords: nil,
          return_type: val[1]
        )

        result = LocatedValue.new(value: type, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1166)
  def _reduce_207(val, _values, result)
            result = val[2]
        result[0].unshift(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1170)
  def _reduce_208(val, _values, result)
            result = empty_params_result
        result[0].unshift(val[0])

    result
  end
.,.,

# reduce 209 omitted

module_eval(<<'.,.,', 'parser.y', 1177)
  def _reduce_210(val, _values, result)
            result = val[2]
        result[1].unshift(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1181)
  def _reduce_211(val, _values, result)
            result = empty_params_result
        result[1].unshift(val[0])

    result
  end
.,.,

# reduce 212 omitted

module_eval(<<'.,.,', 'parser.y', 1188)
  def _reduce_213(val, _values, result)
            result = val[2]
        result[2] = val[0]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1192)
  def _reduce_214(val, _values, result)
            result = empty_params_result
        result[2] = val[0]

    result
  end
.,.,

# reduce 215 omitted

module_eval(<<'.,.,', 'parser.y', 1199)
  def _reduce_216(val, _values, result)
            result = val[2]
        result[3].unshift(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1203)
  def _reduce_217(val, _values, result)
            result = empty_params_result
        result[3].unshift(val[0])

    result
  end
.,.,

# reduce 218 omitted

module_eval(<<'.,.,', 'parser.y', 1210)
  def _reduce_219(val, _values, result)
            result = empty_params_result

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1213)
  def _reduce_220(val, _values, result)
            result = val[2]
        result[4].merge!(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1217)
  def _reduce_221(val, _values, result)
            result = empty_params_result
        result[4].merge!(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1221)
  def _reduce_222(val, _values, result)
            result = val[2]
        result[5].merge!(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1225)
  def _reduce_223(val, _values, result)
            result = empty_params_result
        result[5].merge!(val[0])

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1229)
  def _reduce_224(val, _values, result)
            result = empty_params_result
        result[6] = val[0]

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1235)
  def _reduce_225(val, _values, result)
            loc = val[0].location
        if var_name = val[1]
          loc = loc + var_name.location
        end
        loc = loc.with_children(optional: { name: var_name&.location })

        result = Types::Function::Param.new(
          type: val[0],
          name: var_name&.value&.to_sym,
          location: loc
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1250)
  def _reduce_226(val, _values, result)
            loc = val[0].location + val[1].location
        if var_name = val[2]
          loc = loc + var_name.location
        end
        loc = loc.with_children(optional: { name: var_name&.location })

        result = Types::Function::Param.new(
          type: val[1],
          name: val[2]&.value&.to_sym,
          location: loc
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1265)
  def _reduce_227(val, _values, result)
            loc = val[0].location + val[1].location
        if var_name = val[2]
          loc = loc + var_name.location
        end
        loc = loc.with_children(optional: { name: var_name&.location })

        result = Types::Function::Param.new(
          type: val[1],
          name: val[2]&.value&.to_sym,
          location: loc
        )

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1280)
  def _reduce_228(val, _values, result)
            loc = val[0].location + val[1].location
        if var_name = val[2]
          loc = loc + var_name.location
        end

        loc = loc.with_children(optional: { name: var_name&.location })

        param = Types::Function::Param.new(
          type: val[1],
          name: val[2]&.value&.to_sym,
          location: loc
        )
        result = { val[0].value => param }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1297)
  def _reduce_229(val, _values, result)
            loc = val[0].location + val[2].location
        if var_name = val[3]
          loc = loc + var_name.location
        end

        loc = loc.with_children(optional: { name: var_name&.location })

        param = Types::Function::Param.new(
          type: val[2],
          name: val[3]&.value&.to_sym,
          location: loc
        )
        result = { val[1].value => param }

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1314)
  def _reduce_230(val, _values, result)
            loc = val[0].location + val[1].location
        if var_name = val[2]
          loc = loc + var_name.location
        end

        loc = loc.with_children(optional: { name: var_name&.location })

        result = Types::Function::Param.new(
          type: val[1],
          name: val[2]&.value&.to_sym,
          location: loc
        )

    result
  end
.,.,

# reduce 231 omitted

# reduce 232 omitted

# reduce 233 omitted

# reduce 234 omitted

module_eval(<<'.,.,', 'parser.y', 1333)
  def _reduce_235(val, _values, result)
            namespace = val[0]&.value || Namespace.empty
        name = val[1].value.to_sym
        type_name = TypeName.new(namespace: namespace, name: name)
        location = (loc0 = val[0]&.location) ? loc0 + val[1].location : val[1].location
        result = LocatedValue.new(value: type_name, location: location)

    result
  end
.,.,

# reduce 236 omitted

# reduce 237 omitted

# reduce 238 omitted

module_eval(<<'.,.,', 'parser.y', 1345)
  def _reduce_239(val, _values, result)
            namespace = val[0]&.value || Namespace.empty
        name = val[1].value.to_sym
        type_name = TypeName.new(namespace: namespace, name: name)
        location = (loc0 = val[0]&.location) ? loc0 + val[1].location : val[1].location
        result = LocatedValue.new(value: type_name, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1354)
  def _reduce_240(val, _values, result)
            namespace = val[0]&.value || Namespace.empty
        name = val[1].value.to_sym
        type_name = TypeName.new(namespace: namespace, name: name)
        location = (loc0 = val[0]&.location) ? loc0 + val[1].location : val[1].location
        result = LocatedValue.new(value: type_name, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1363)
  def _reduce_241(val, _values, result)
            namespace = val[0]&.value || Namespace.empty
        name = val[1].value.to_sym
        type_name = TypeName.new(namespace: namespace, name: name)
        location = (loc0 = val[0]&.location) ? loc0 + val[1].location : val[1].location
        result = LocatedValue.new(value: type_name, location: location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1373)
  def _reduce_242(val, _values, result)
            result = nil

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1376)
  def _reduce_243(val, _values, result)
            result = LocatedValue.new(value: Namespace.root, location: val[0].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1379)
  def _reduce_244(val, _values, result)
            namespace = Namespace.parse(val[1].value).absolute!
        result = LocatedValue.new(value: namespace, location: val[0].location + val[1].location)

    result
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 1383)
  def _reduce_245(val, _values, result)
            namespace = Namespace.parse(val[0].value)
        result = LocatedValue.new(value: namespace, location: val[0].location)

    result
  end
.,.,

# reduce 246 omitted

# reduce 247 omitted

def _reduce_none(val, _values, result)
  val[0]
end

  end   # class Parser
end   # module RBS


